


#include <p18f4550.h>

#include "h/Platine.h"

#include "h/SPI.h"
#include "h/Parametres.h"
#include "h/Utilitaires.h"
#include "h/Graphique.h"



#define PLATINE_LCD_RETROECLAIRAGE 6
#define PLATINE_LCD_LED 7



extern unsigned char g_EtatDuRetroeclairage;
extern unsigned char g_EtatLEDGraphique;
extern unsigned char g_BlocActuel;



unsigned char InitialiserModuleGraphique(void)
{
	BROCHE_CS = 1;	/* ~CS_MCP23S117 = 1. */



	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x00, 0x00, 0x00);
	Delai(100);
	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, 0x00, 0x00);



	ChangerEtatLED(1);
	Delai(300);
	ChangerEtatLED(0);
	ChangerEtatLED(1);
	Delai(300);
	ChangerEtatLED(0);
	ChangerEtatLED(1);
	Delai(300);
	ChangerEtatLED(0);
	ChangerEtatRetroeclairage(1);
	InitialiserAfficheurGraphique(1);
	InitialiserAfficheurGraphique(0);
	
	EffacerAfficheurGraphique(0);
	ChangerEtatLED(0);



	return 1;
}

unsigned char ChangerEtatLED(unsigned char Commande)
{
	unsigned char Etat = 0;
	
	Etat |= (g_EtatDuRetroeclairage | g_BlocActuel);

	Commande &= 0x01;

	Commande <<= PLATINE_LCD_LED;

	if(g_EtatLEDGraphique == Commande)
	{
		return 0;
	}

	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, 0x00, (Etat | Commande));

	g_EtatLEDGraphique = Commande;

	return 1;
}
	
unsigned char ChangerEtatRetroeclairage(unsigned char Commande)
{
	unsigned char Etat = 0;

	Etat |= (g_EtatLEDGraphique | g_BlocActuel);

	Commande &= 0x01;

	Commande <<= PLATINE_LCD_RETROECLAIRAGE;

	if(g_EtatDuRetroeclairage == Commande)
	{
		return 0;
	}

	EcrireRegistreExpanseur(AdresseModuleGraphique, 0x12, 0x00, (Etat | Commande));

	g_EtatDuRetroeclairage = Commande;

	return 1;
}


