



#include <p18f4550.h>

#include "h/SPI.h"
#include "h/Graphique.h"
#include "h/Platine.h"
#include "h/Parametres.h"
#include "h/Images.h"
#include "h/Utilitaires.h"





#pragma config BOR = ON
#pragma config MCLRE = OFF
#pragma config LVP = OFF
#pragma config PBADEN = OFF
#pragma config DEBUG = OFF
#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config PWRT = OFF
#pragma config WDT = OFF
#pragma config WDTPS = 1024
#pragma config LPT1OSC = OFF
#pragma config XINST = OFF
#pragma config STVREN = OFF 
#pragma config FOSC = INTOSCIO_EC



void InitialisationMicrocontroleur(void);



void InitialisationMicrocontroleur(void)
{
	OSCCON = 0x72;

	OSCTUNE = 0x00;

	CCP1CON = 0;

	ADCON1 = 0x0F; 
   
	T1CON = 0b10000000;
}

void main(void)
{
	int k = 0;
	int u = 0;

	unsigned char E1 = 0x00;
 	unsigned char E2 = 0x00;

	InitialisationMicrocontroleur();

	INTCONbits.GIE = 0;	/* Dsactivation des interruptions du microcontrleur PIC18F4550. */
	
	TRISA = 0x00;
	TRISB = 0x0F;
	TRISC = 0x00;
	TRISD = 0x00;
	TRISE = 0xFC;

	DIRECTION_CS = 0;	/* Broche  ~CS  du microcontrleur PIC18F4550, configure en tant que sortie. */
	DIRECTION_SDI = 1;	/* Broche  SDI  du microcontrleur PIC18F4550, configure en tant qu' entre. */
	DIRECTION_SCK = 0;	/* Broche  SCK  du microcontrleur PIC18F4550, configure en tant que sortie. */
	DIRECTION_SDO = 0;	/* Broche  SDO  du microcontrleur PIC18F4550, configure en tant que sortie. */

	InitialisationSPI();

	InitialiserModuleGraphique();
	
	Delai(300);

	ChangerEtatLED(1);

   	EffacerAfficheurGraphique(0);

	Delai(3000);

	AfficherLesBlocs();

	Delai(3000);

	EffacerAfficheurGraphique(0);
	PositionnerCurseurXYGraphique(1, 1);
	AfficherLesPages();

	Delai(3000);

   	EffacerAfficheurGraphique(0);

	TracerPointXYGraphique(7, 16, 1);
	TracerRectangleGraphique(28, 15, 9, 29, 1);
	TracerCadreGraphique(9, 39, 68, 19, 1);

	Delai(3000);

	for(k = 0; k < 2; k++)
	{
		EffacerAfficheurGraphique(1 - k);

		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope\0", k);
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_LARGEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	}

	EffacerAfficheurGraphique(0);

	while(1)
	{
		/* Dbut de l'affichage du texte simple */
		ChangerEtatLED(0);
		Delai(100000);
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Coucou !\0", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte simple\0", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte simple */

		/* Dbut de l'affichage du texte avec inversion */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Salut Ginette !\0", ATTRIBUT_NORMAL);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte avec inversion\0", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte avec inversion */

		/* Dbut de l'affichage du texte de taille double */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Nyctalope\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte double\0", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte de taille double */

		/* Dbut de l'affichage du texte de taille double, avec inversion */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("0356209917\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_NORMAL));
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte double, inv.\0", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte de taille double */

		/* Dbut de l'affichage du (faux) texte long */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam volutpat tortor sed eros auctor id fringilla ligula eleifend. Integer faucibus est qui\0", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("(Faux) Texte long\0", ATTRIBUT_POSITIF);
		Delai(300000);
		/* Fin de l'affichage du (faux) texte long */

		/* Dbut de l'affichage de l'ensemble des symboles affichables */
		EffacerAfficheurGraphique(0);
		for(k = 0x20; k < 0x83; k++)
		{
			AfficherCaractereGraphique(k, ATTRIBUT_POSITIF);
		}
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Symboles affichables", ATTRIBUT_POSITIF);
		Delai(300000);
		
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Comptage\0", ATTRIBUT_POSITIF);
		for(u = (-100); u <= 180; u++)
		{
			PositionnerCurseurXYGraphique(16, 3);
			ConvertirAfficherGraphique(u, 10, (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			AfficherTexteGraphique("  ", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(10);
		}
		Delai(300000);
		/* Fin de l'affichage de l'ensemble des symboles affichables */

		/* Dbut de l'affichage de la barre de chargement */
		/* Dbut du dessin de la barre de chargement, vide */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Barre de chargement\0", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(12, 2);
		EnvoyerDonneeGraphique(0xFF);
		EnvoyerDonneeGraphique(0x81);
		for(u = 0; u <= 100; u++)
		{
			EnvoyerDonneeGraphique(0x81);
		}
		EnvoyerDonneeGraphique(0x81);
		EnvoyerDonneeGraphique(0xFF);

		/* Fin du dessin de la barre de chargement, vide */

		/* Dbut du remplissage de la barre de chargement, et de l'augmentation du pourcentage de son remplissage */
		for(u = 0; u <= 100; u++)
		{
			PositionnerCurseurXYGraphique((14 + u), 2);
			EnvoyerDonneeGraphique(0xBD);
		
			PositionnerCurseurXYGraphique(43, 4);
			ConvertirAfficherGraphique(u, 10, (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			AfficherTexteGraphique("% \0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(3000);
		}
		/* Fin du remplissage de la barre de chargement, et de l'augmentation du pourcentage de son remplissage*/

		Delai(300000);

		/* Fin de l'affichage de la barre de chargement */
		
		/* Dbut de l'affichage du  Trollface  */
		EffacerAfficheurGraphique(0);
		/* AfficherImageGraphique(Trollface, 1); */
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Image : Trollface !", ATTRIBUT_POSITIF);
		Delai(300000);
		/* Fin de l'affichage du  Trollface  */

		/* Dbut du changement de l'tat du rtroclairage de l'afficheur graphique */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Commande allumage\0", ATTRIBUT_POSITIF);
		for(u = 0; u <= 5; u++)
		{
			ChangerEtatRetroeclairage(0);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Nuit\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
			
			ChangerEtatRetroeclairage(1);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Jour\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
		}

		Delai(300000);
		/* Fin du changement de l'tat du rtroclairage de l'afficheur graphique */

		/* Dbut du changement de l'tat de la LED du module de l'afficheur graphique */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Commande LED\0", ATTRIBUT_POSITIF);
		for(u = 0; u <= 5; u++)
		{
			ChangerEtatLED(0);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Non\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
			
			ChangerEtatLED(1);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Oui\0", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
		}

		Delai(300000);
		/* Fin du changement de l'tat de la LED du module de l'afficheur graphique */

		}
}





#pragma interrupt InterruptHandler   
void InterruptHandler (void)
{
	unsigned short i;

}

#pragma code InterruptVectorHigh = 0x08 
void InterruptVectorHigh(void)
{
    _asm
        goto InterruptHandler
    _endasm
}
 

